#ifndef __HACKS1DM_H
#define __HACKS1DM_H

#include "PATCHACK.H"

/* demo */

/* Options hacks */

static fix_item dmmusvol[] = {
  {0x0A034C5AUL, 0x0A},
  /* actual music volume byte */
  {0x7F07943CUL, 0x7F}
};

static fix_item dmsndvol[] = {
  {0x0A034C64UL, 0x0A}
};

static fix_item dmdfflev[] = {
  {0x02034CD9UL, 0x02}
};

static fix_item dmhazlev[] = {
  {0x010420A1UL, 0x01}
};

static fix_item dmflrlev[] = {
  {0x01041E92UL, 0x01}
};

static fix_item dmwlldet[] = {
  {0x00041E88UL, 0x00}
};

static fix_item dmmsesns[] = {
  {0x01034CF5UL, 0x01}
};

static fix_info dmlsopts[] = {
  {PH_ORG, 0, LIST_LEN(dmmusvol), dmmusvol},
  {PH_ORG, 0, LIST_LEN(dmsndvol), dmsndvol},
  {PH_ORG, 0, LIST_LEN(dmdfflev), dmdfflev},
  {PH_ORG, 0, LIST_LEN(dmhazlev), dmhazlev},
  {PH_ORG, 0, LIST_LEN(dmflrlev), dmflrlev},
  {PH_ORG, 0, LIST_LEN(dmwlldet), dmwlldet},
  {PH_ORG, 0, LIST_LEN(dmmsesns), dmmsesns}
};

/* Hacks setup */

static fix_item dmhkstrf[] = {
  /*
    explanation for the strafe code hack
    * pair of two consecutive null funcs at offsets 0005096F, 00050984 and 00051C8B, 00051CA0 was
      used for strafe code placing in the game executable file, since it's new additional feature
      and nothing should be changed, replaced or removed
    * null func is a func that does nothing, but useless pushes and pops registers to / from stack
      so if func immediately returns (C3) all these wasted bytes can be used for something meaningful
      and if you wonder why this code exists in the first place - it's because compilers at that time
      didn't optimize and remove unused or obviously empty code (it's nice, since this come in handy)
    * let's see main idea behind this hack on Strafe Left implementation:
      - Turn Left to 90* degree
      - Move Forward
      - Turn Right to 90* degree to restore original view angle
      the same with the Strafe Right except calls for the Turn Left and Turn Right will be exchanged
    * note that 2880 (0B40h) equal to the 90* degree in the game units
  */
  /* Turn Left => Strafe Left */
  {0x12042BEBUL, 0x0E}, /* replace rotate coeff with move coeff */
  {0x12042BFFUL, 0x0E},
  {0xEA042C36UL, 0x36}, /* replace TurnLeft call to [SL1] */
  {0xD2042C37UL, 0xDD},
  {0xFF042C38UL, 0x00},
  {0xFF042C39UL, 0x00},
  /* Turn Right => Strafe Right */
  {0x12042C5BUL, 0x0E}, /* replace rotate coeff with move coeff */
  {0x12042C6FUL, 0x0E},
  {0xF1042C9FUL, 0xE9}, /* replace TurnLeft call to [SR1] */
  {0xD2042CA0UL, 0xEF},
  {0xFF042CA1UL, 0x00},
  {0xFF042CA2UL, 0x00},
  /* Strafe Left func instead of two null funcs */
  {0x5305096FUL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51050970UL, 0x52}, /* [SL1] push edx - save argument (distance to move) */
  {0x52050971UL, 0x50}, /* push eax - save argument (global data offset to structure) */
  {0x56050972UL, 0xBA}, /* mov  edx, 0B40h - angle - 90 degree in the game units */
  {0x57050973UL, 0x40},
  {0x55050974UL, 0x0B},
  {0x89050975UL, 0x00},
  {0xE5050976UL, 0x00},
  {0x81050977UL, 0x52}, /* push edx - save angle */
  {0xEC050978UL, 0xE8}, /* call TurnLeft(eax:struct, edx:angle, ebx:0) - turn 90 degree to the left */
  {0x00050979UL, 0xA7},
  {0x0005097AUL, 0xF5},
  {0x0005097BUL, 0xFE},
  {0x0005097CUL, 0xFF},
  {0x5D05097DUL, 0x5B}, /* pop ebx - get angle */
  {0x5F05097EUL, 0x58}, /* pop eax - get struct */
  {0x5E05097FUL, 0x5A}, /* pop edx - get distance */
  {0x5A050980UL, 0x50}, /* push eax - save struct */
  {0x59050981UL, 0x53}, /* push ebx - save angle */
  {0x5B050982UL, 0xEB}, /* jump to [SL2] */
  {0xC3050983UL, 0x01},
  {0x53050984UL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51050985UL, 0x33}, /* [SL2] xor ebx, ebx - ebx must be zero (optional flag) */
  {0x52050986UL, 0xDB},
  {0x56050987UL, 0xE8}, /* call MoveForward(eax:struct, edx:distance, ebx:0) */
  {0x57050988UL, 0x78},
  {0x55050989UL, 0xEE},
  {0x8905098AUL, 0xFE},
  {0xE505098BUL, 0xFF},
  {0x8105098CUL, 0x33}, /* xor ebx, ebx - ebx must be zero (optional flag) */
  {0xEC05098DUL, 0xDB},
  {0x0005098EUL, 0x5A}, /* pop edx - get angle */
  {0x0005098FUL, 0x58}, /* pop eax - get struct */
  {0x00050990UL, 0xE9}, /* jmp TurnRight(eax:struct, edx:angle, ebx:0) - turn 90 degree to the right... */
  {0x00050991UL, 0xFF}, /* ...this will allow to return look angle back as it was before strafe... */
  {0x5D050992UL, 0xF5}, /* ...also note jmp here instead of call - shorter code */
  {0x5F050993UL, 0xFE},
  {0x5E050994UL, 0xFF},
  /* Strafe Right func instead of two null funcs */
  {0x53051C8BUL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51051C8CUL, 0x52}, /* [SR1] */
  {0x52051C8DUL, 0x50},
  {0x56051C8EUL, 0xBA},
  {0x57051C8FUL, 0x40},
  {0x55051C90UL, 0x0B},
  {0x89051C91UL, 0x00},
  {0xE5051C92UL, 0x00},
  {0x81051C93UL, 0x52},
  {0xEC051C94UL, 0xE8}, /* call TurnRight() */
  {0x00051C95UL, 0xFB},
  {0x00051C96UL, 0xE2},
  {0x00051C97UL, 0xFE},
  {0x00051C98UL, 0xFF},
  {0x5D051C99UL, 0x5B},
  {0x5F051C9AUL, 0x58},
  {0x5E051C9BUL, 0x5A},
  {0x5A051C9CUL, 0x50},
  {0x59051C9DUL, 0x53},
  {0x5B051C9EUL, 0xEB}, /* jump to [SR2] */
  {0xC3051C9FUL, 0x01},
  {0x53051CA0UL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51051CA1UL, 0x33}, /* [SR2] */
  {0x52051CA2UL, 0xDB},
  {0x56051CA3UL, 0xE8}, /* call MoveForward() */
  {0x57051CA4UL, 0x5C},
  {0x55051CA5UL, 0xDB},
  {0x89051CA6UL, 0xFE},
  {0xE5051CA7UL, 0xFF},
  {0x81051CA8UL, 0x33},
  {0xEC051CA9UL, 0xDB},
  {0x00051CAAUL, 0x5A},
  {0x00051CABUL, 0x58},
  {0x00051CACUL, 0xE9}, /* jmp TurnLeft() */
  {0x00051CADUL, 0x73},
  {0x5D051CAEUL, 0xE2},
  {0x5F051CAFUL, 0xFE},
  {0x5E051CB0UL, 0xFF}
};

static fix_item dmhkmsvw[] = {
  /* fall through EVT_MOUSE_MOVING check (mouse usage always on) */
  {0x0A042CAFUL, 0x00},
  {0x03042CB0UL, 0x00},
  /* fall through first check - set mouse cursor to the screen center */
  {0x34042CCBUL, 0x00},
  /* fall through second check - always test for out of bounds */
  {0x75042CFCUL, 0x00},
  /* skip MoveForward / MoveBackward code for mouse */
  {0x0F042EA7UL, 0x90},
  {0x8D042EA8UL, 0xE9},
  {0x80042EA9UL, 0x17},
  {0x00042EAAUL, 0x01}
};

static fix_item dmhkmsen[] = {
  /* TurnLeft() increase sensivity */
  {0x0603FF61UL, 0x06},
  /* TurnRight() increase sensivity */
  {0x0603FFD1UL, 0x06}
};

static fix_item dmhkgive[] = {
  /* all weapons available mask */
  {0x0504A898UL, 0x7F},
  /* 200 bullets for pistol / machine gun */
  {0x1404A8AFUL, 0xC8},
  /* 50 grenades for grenade launcher */
  {0x0004A8BAUL, 0x32},
  /* 75 gas for flame thrower */
  {0x0004A8C5UL, 0x4B},
  /* 100 energy for last mystery weapon */
  {0x0004A8D0UL, 0x64}
};

static fix_item dmhkhlth[] = {
  /* infinite health */
  {0x010469D8UL, 0x00}
};

static fix_item dmhksmap[] = {
  /* show map */
  {0x000469E2UL, 0x01}
};

static fix_item dmhkvmod[] = {
  /* view mode */
  {0x010469C4UL, 0x00},
  {0x010469CEUL, 0x00}
};

static fix_item dmhkammo[] = {
  /* infinite ammo */
  {0x000469A6UL, 0x01}
};

static fix_item dmhkwall[] = {
  /* walk through walls - noclip */
  {0x0104697EUL, 0x00}
};

static fix_item dmhkcrds[] = {
  /* show coords */
  {0x00046974UL, 0x01}
};

static fix_info dmlshack[] = {
  {PH_ORG, 0, LIST_LEN(dmhkstrf), dmhkstrf},
  {PH_ORG, 0, LIST_LEN(dmhkmsvw), dmhkmsvw},
  {PH_ORG, 0, LIST_LEN(dmhkmsen), dmhkmsen},
  {PH_ORG, 0, LIST_LEN(dmhkgive), dmhkgive},
  {PH_ORG, 0, LIST_LEN(dmhkhlth), dmhkhlth},
  {PH_ORG, 0, LIST_LEN(dmhkammo), dmhkammo},
  {PH_ORG, 0, LIST_LEN(dmhksmap), dmhksmap},
  {PH_ORG, 0, LIST_LEN(dmhkcrds), dmhkcrds},
  {PH_ORG, 0, LIST_LEN(dmhkvmod), dmhkvmod},
  {PH_ORG, 0, LIST_LEN(dmhkwall), dmhkwall}
};

#endif
