#include <stddef.h>
#include <string.h>
#include <bios.h>
#include <dos.h>
/* for gotoxy() NTVDM hack */
#include <conio.h>

#include "modsetup.h"

WORD scrbuf[80*50];
BYTE scrmod;
WORD curlen, curpos;
WORD far *scrmem = MK_FP(0xB800, 0x0000);

char strHint[] = "<Esc> Back  \x18\x19 Move  \x11\xC4\xD9 Selects";
char strInfo[] = "Press any key to continue";
char strDlgs[] = "Esc Aborts";
BYTE lines[4][3] = {
  /* /-\ */
  {0xDA, 0xC4, 0xBF},
  /* | | */
  {0xB3, 0x20, 0xB3},
  /* |-| */
  {0xC3, 0xC4, 0xB4},
  /* \-/ */
  {0xC0, 0xC4, 0xD9}
};
static char strMark[2][2][4] = {
  {"( )", "(*)"}, /* \x07 */
  {"[ ]", "[v]"}  /* \xFB */
};

void UpdScreen(WORD p) {
union REGS rs;
  rs.h.ah = 0x02;
  rs.h.bh = 0x00;
  rs.x.dx = p;
  int86(0x10, &rs, &rs);
}

int Bounds(int vcur, int vmin, int vmax) {
  if (vcur < vmin) { vcur = vmin; }
  if (vcur > vmax) { vcur = vmax; }
  return(vcur);
}

void FillLine(int x, int y, int w, WORD f) {
int i;
  if (y < 25) {
    y *= 80;
    for (i = 0; i < w; i++) {
      if ((x + i) < 80) {
        scrmem[y + x + i] = f;
      }
    }
  }
}

void DrawText(int x, int y, char *s) {
  x = Bounds(x, 0, 79);
  y = Bounds(y, 0, 24);
  y *= 80;
  for (; *s; s++) {
    if ((x < 80) && ((y + x) < 80*25)) {
      scrmem[y + x] = (scrmem[y + x] & 0xFF00) | ((BYTE) *s);
      x++;
    }
  }
  UpdScreen(0x1900);
}

void DrawItem(int x, int y, menuitem *item, WORD t) {
int i, k, f, c, l;
  c = (t & 0xC000) >> 14;
  k = (item->flag & (ITEM_CHKBOX | ITEM_RADBOX)) ? 4 : 0;
  if (item->flag & ITEM_GRAYED) {
    t = t ? 0x7800 : 0x1800;
  } else {
    t = t ? 0xF100 : 0x1F00;
  }
  f = c ? 2 : 0;
  l = 0;
  for (i = 0; item->item[i]; i++) {
    if ((x + i) < 80) {
      if ((f == 2) && (item->item[i] != ' ')) {
        f = 1;
      }
      if ((f == 1) && (item->item[i] == ' ')) {
        f = 2;
        l++;
      }
      if ((f < 2) && ((!c) || (c == l) || (!l))) {
        scrmem[(y*80) + k + x + i] = (scrmem[(y*80) + k + x + i] & 0x00FF) | t;
      }
    }
  }
  if (k) {
    FillLine(x, y, 4, (item->flag & ITEM_GRAYED) ? 0x1820 : 0x1F20);
    DrawText(x, y, strMark[(item->flag & ITEM_CHKBOX) ? 1 : 0][(item->flag & ITEM_HILITE) ? 1 : 0]);
  }
  DrawText(x + k, y, item->item);
}

void HintText(char *s) {
  FillLine(0, 24, 80, 0x7020);
  if (s) {
    DrawText((80 - strlen(s)) / 2, 24, s);
  }
}

void DrawLine(int x, int y, int w, int t) {
int i, k;
  for (i = 0; i < w; i++) {
    k = 1;
    if ((i == 0)) {
      k = 0;
    }
    if (i == (w - 1)) {
      k = 2;
    }
    scrmem[(y*80) + x + i] = (scrmem[(y*80) + x + i] & 0xFF00) | lines[t][k];
  }
}

void DrawRect(int x, int y, int w, int h, WORD a) {
int i, j;
  /* menu */
  for (j = 0; j < h; j++) {
    FillLine(x, y + j, w, a);
  }
  /* right shadow */
  for (j = 1; j < h; j++) {
    for (i = 0; i < 2; i++) {
      if ((x + w + i) < 80) {
        scrmem[((y + j)*80) + x + w + i] = (scrmem[((y + j)*80) + x + w + i] & 0x00FF) | 0x0800;
      }
    }
  }
  /* bottom shadow */
  j = y + h;
  if (j < 24) {
    j *= 80;
    x += 2;
    for (i = 0; i < w; i++) {
      if ((x + i) < 80) {
        scrmem[j + x + i] = (scrmem[j + x + i] & 0x00FF) | 0x0800;
      }
    }
  }
}

int DoMenu(int x, int y, menuitem *items, PMENUPROC mp) {
BYTE key;
int i, j;
  for (i = 0; i < (items[0].flag & MENU_ITEMSK); i++) {
    if ((items[i + 1].flag & ITEM_HILITE) && (!(items[i + 1].flag & ITEM_CHKBOX))) {
      break;
    }
  }
  if (i >= (items[0].flag & MENU_ITEMSK)) {
    i = 0;
  }
  do {
    DrawItem(x, y + i, &items[i + 1], 1 | (((items[0].flag & MENU_ROWCOL) == MENU_ROWCOL) ? (((items[i + 1].flag + 1) & 3) << 14) : 0));
    HintText(items[i + 1].hint);
    key = ((WORD) bioskey(0)) >> 8;
    DrawItem(x, y + i, &items[i + 1], 0);
    switch (key) {
      case VK_UP:
        j = i;
        do {
          i = (i > 0) ? (i - 1) : ((items[0].flag & MENU_ITEMSK) - 1);
        } while ((j != i) && (items[1 + i].flag & ITEM_GRAYED) && (!items[1 + i].item[0]));
        break;
      case VK_DOWN:
        j = i;
        do {
          i = ((i + 1) < (items[0].flag & MENU_ITEMSK)) ? (i + 1) : 0;
        } while ((j != i) && (items[1 + i].flag & ITEM_GRAYED) && (!items[1 + i].item[0]));
        break;
      case VK_HOME:
        i = 0;
        break;
      case VK_END:
        i = (items[0].flag & MENU_ITEMSK) - 1;
        break;
      case VK_BSPACE:
        key = VK_ESCAPE;
      case VK_ESCAPE:
        break;
      case VK_SPACE:
        key = VK_RETURN;
      case VK_RETURN:
        if (items[i + 1].flag & ITEM_GRAYED) {
          key = 0;
        } else {
          if (items[i + 1].flag & (ITEM_CHKBOX | ITEM_RADBOX)) {
            if (items[i + 1].flag & ITEM_CHKBOX) {
              items[i + 1].flag ^= ITEM_HILITE;
            } else {
              /* drop old selection */
              for (j = 0; j < (items[0].flag & MENU_ITEMSK); j++) {
                if (items[j + 1].flag & ITEM_HILITE) {
                  /* not the same */
                  if (i != j) {
                    items[j + 1].flag ^= ITEM_HILITE;
                    DrawItem(x, y + j, &items[j + 1], 0);
                  }
                  break;
                }
              }
              /* select current */
              items[i + 1].flag |= ITEM_HILITE;
            }
            key = 0;
          }
          if (mp) {
            j = mp(i + 1, NULL);
            if (j) { key = 0; }
            /* special case: redraw/update this menu items */
            if (j == -1) {
              for (j = 0; j < (items[0].flag & MENU_ITEMSK); j++) {
                DrawItem(x, y + j, &items[j + 1], 0);
              }
            }
          }
        }
        break;
      default:
        if (mp && mp(i + 1, &key)) {
          key = 0;
        }
        break;
    }
  } while ((key != VK_ESCAPE) && (key != VK_RETURN));
  return((key == VK_RETURN) ? (i + 1) : 0);
}

int DrawMenu(menuitem *items, PMENUPROC mp) {
WORD back[80*25];
int i, x, y, w, h, t, d;
char *s;
  /* save screen buffer */
  for (i = 0; i < 80*25; i++) {
    back[i] = scrmem[i];
  }
  h = 6 + (items[0].flag & MENU_ITEMSK);
  w = 0;
  for (i = 0; i < (items[0].flag & MENU_ITEMSK); i++) {
    t = strlen(items[i + 1].item) + ((items[i + 1].flag & (ITEM_CHKBOX | ITEM_RADBOX)) ? 4 : 0);
    if (w < t) { w = t; }
  }
  d = w;
  t = strlen(items[0].item);
  if (w < t) { w = t; }
  s = strHint;
  if ((items[0].flag & MENU_ROWCOL) != MENU_ROWCOL) {
    if (items[0].flag & MENU_NFOBOX) {
      s = strInfo;
    }
    if (items[0].flag & MENU_DLGBOX) {
      s = strDlgs;
    }
  }
  t = strlen(s);
  if (w < t) { w = t; }
  if (items[0].hint) {
    t = strlen(items[0].hint);
    if (w < t) { w = t; }
    h += 2;
  }
  w += 4;
  w = Bounds(w, 4, 80);
  h = Bounds(h, 4, 23);
  x = Bounds((80 - w) / 2, 0, 79);
  y = Bounds((25 - h) / 2, 1, 23);
  DrawRect(x, y, w, h, 0x1B20);
  for (i = 0; i < h; i++) {
    t = 1;
    if (i == 0) {
      t = 0;
    }
    if (i == (h - 1)) {
      t = 3;
    }
    if ((i == 2) || (i == (h - 3))) {
      t = 2;
    }
    if (items[0].hint && (i == 4)) {
      t = 2;
    }
    DrawLine(x, y + i, w, t);
  }
  /* header */
  DrawText(x + (w - strlen(items[0].item)) / 2, y + 1, items[0].item);
  t = 3;
  /* subheader */
  if (items[0].hint) {
    /* green color */
    FillLine(x + 2, y + 3, w - 4, 0x1A20);
    DrawText(x + 2, y + 3, items[0].hint);
    t += 2;
  }
  /* bottom hint */
  DrawText(x + ((w - strlen(s)) / 2), y + h - 2, s);
  /* dialog box - center menu items */
  d = /*((items[0].flag & MENU_ROWCOL) == MENU_DLGBOX) ? */((w - d - 4) / 2)/* : 0*/;
  /* draw menu items */
  for (i = 0; i < (items[0].flag & MENU_ITEMSK); i++) {
    DrawItem(x + 2 + d, y + t + i, &items[i + 1], 0);
  }
  if ((items[0].flag & MENU_ROWCOL) == MENU_NFOBOX) {
    bioskey(0);
    t = 0;
  } else {
    t = DoMenu(x + 2 + d, y + t, items, mp);
  }
  /* restore screen buffer */
  for (i = 0; i < 80*25; i++) {
    scrmem[i] = back[i];
  }
  return(t);
}

int DrawInfo(menuitem *item, PMENUPROC mp) {
WORD back[80*25];
int i, t, x, y, w, h;
char *s;
  /* save screen buffer */
  for (i = 0; i < 80*25; i++) {
    back[i] = scrmem[i];
  }
  h = 2 + (item->item ? 1 : 0) + (item->flag ? 2 : 0);
  w = item->item ? strlen(item->item) : 0;
  if (item->flag) {
    s = item->hint ? item->hint : strInfo;
  } else {
    s = NULL;
  }
  x = s ? strlen(s) : 0;
  w = (x > w) ? x : w;
  w += 4;
  w = Bounds(w, 4, 80);
  h = Bounds(h, 3, 5);
  x = Bounds((80 - w) / 2, 0, 79);
  y = Bounds((25 - h) / 2, 1, 23);
  DrawRect(x, y, w, h, item->flag ? 0x4F20 : 0x4E20);
  for (i = 0; i < h; i++) {
    t = 1;
    if (i == 0) {
      t = 0;
    }
    if (i == (h - 1)) {
      t = 3;
    }
    DrawLine(x, y + i, w, t);
  }
  if (item->item) {
    DrawText(x + ((w - strlen(item->item)) / 2), y + 1, item->item);
  }
  if (item->flag && s) {
    FillLine(x + 2, y + 1 + 2, w - 4, 0x4720);
    DrawText(x + ((w - strlen(s)) / 2), y + 1 + 2, s);
  }
  /* call user proc or just wait for key */
  if (mp) {
    x = mp(0, NULL);
  } else {
    bioskey(0);
    x = 0;
  }
  /* restore screen buffer */
  for (i = 0; i < 80*25; i++) {
    scrmem[i] = back[i];
  }
  return(x);
}

void DefMenuItem(menuitem *menu, int item) {
int i;
  i = menu[0].flag & MENU_ITEMSK;
  while (i--) {
    SET_LITE(menu[1 + i], i == item);
  }
}

/* this will add spaces to the menu items
   so the submenu item names can be added */
void FillMenu(menuitem *menu, char *s, int l) {
int i, j;
char *t;
  for (i = 0; i < (menu[0].flag & MENU_ITEMSK); i++) {
    if (menu[1 + i].flag & ITEM_HILITE) {
      menu[1 + i].flag ^= ITEM_HILITE;
      t = menu[1 + i].item;
      menu[1 + i].item = s;
      for (j = 0; j < l; j++) {
        *s = *t ? *t : ' ';
        t += *t ? 1 : 0;
        s++;
      }
      *s = 0;
      s++;
    }
  }
}

void InitSetup(char *l, char *r) {
union REGS rs;
int i;
  /* save screen buffer */
  for (i = 0; i < 80*50; i++) {
    scrbuf[i] = scrmem[i];
  }
  /* get current mode */
  rs.h.ah = 0x0F;
  int86(0x10, &rs, &rs);
  scrmod = rs.h.al;
  /* get current cursor info */
  rs.h.ah = 0x03;
  rs.h.bh = 0x00;
  int86(0x10, &rs, &rs);
  curlen = rs.x.cx;
  curpos = rs.x.dx;
  /* set mode 80x25 */
  rs.h.ah = 0x00;
  rs.h.al = 0x03;
  int86(0x10, &rs, &rs);
  /* hide cursor */
  rs.h.ah = 0x01;
  rs.x.cx = 0x2020;
  int86(0x10, &rs, &rs);
  /* disable blinking */
  rs.x.ax = 0x1003;
  rs.h.bl = 0;
  int86(0x10, &rs, &rs);
  /* fast keyboard */
  rs.x.ax = 0x0305;
  rs.x.bx = 0x0000;
  int86(0x16, &rs, &rs);
  /* draw background */
  for (i = 0; i < 80*25; i++) {
    scrmem[i] = ((i < 80) || (i >= 80*24)) ? 0x7020 : 0x80B0;
  }
  DrawText(79 - strlen(r), 0, r);
  DrawText(1, 0, l);
  UpdScreen(0x1900);
}

void FreeSetup(void) {
union REGS rs;
int i;
  /* enable blinking */
  rs.x.ax = 0x1003;
  rs.h.bl = 1;
  int86(0x10, &rs, &rs);
  /* restore video mode */
  rs.h.ah = 0x00;
  rs.h.al = scrmod;
  int86(0x10, &rs, &rs);
  /* show cursor */
  rs.h.ah = 0x01;
  rs.x.cx = curlen;
  int86(0x10, &rs, &rs);
  /* restore videomemory */
  for (i = 0; i < 80*50; i++) {
    scrmem[i] = scrbuf[i];
  }
  UpdScreen(0);
  /* NTVDM text screen update */
  gotoxy((curpos & 0xFF) + 1, (curpos >> 8) + 1);
}
