#ifndef __MODSETUP_H
#define __MODSETUP_H

#ifndef BYTE
#define BYTE unsigned char
#endif

#ifndef WORD
#define WORD unsigned short
#endif

#ifndef DWORD
#define DWORD unsigned long
#endif

#define ITEM_CHKBOX 0x8000
#define ITEM_RADBOX 0x4000
#define ITEM_GRAYED 0x2000
#define ITEM_HILITE 0x1000

#define MENU_NFOBOX 0x8000
#define MENU_DLGBOX 0x4000
#define MENU_ROWCOL 0xC000
#define MENU_ITEMSK 0x3FFF

#define GetMenuData(x) ((x).flag & 0x0FFF)
#define SetMenuData(x,d) (x).flag = ((x).flag & 0xF000) | ((d) & 0x0FFF)
#define SET_LITE(m,s) (m).flag = (((m).flag | ITEM_HILITE) ^ ((s) ? 0 : ITEM_HILITE))
#define SET_GRAY(m,s) (m).flag = (((m).flag | ITEM_GRAYED) ^ ((s) ? 0 : ITEM_GRAYED))
#define ITS_LITE(m) ((m).flag & ITEM_HILITE)
#define ITS_GRAY(m) ((m).flag & ITEM_GRAYED)

#define VK_UP     0x48
#define VK_DOWN   0x50
#define VK_LEFT   0x4B
#define VK_RIGHT  0x4D
#define VK_ESCAPE 0x01
#define VK_BSPACE 0x0E
#define VK_TAB    0x0F
#define VK_RETURN 0x1C
#define VK_SPACE  0x39
#define VK_HOME   0x47
#define VK_END    0x4F
#define VK_DELETE 0x53

#pragma pack(push, 1)
typedef struct {
  char *item;
  char *hint;
  WORD  flag;
} menuitem;
#pragma pack(pop)

typedef int (*PMENUPROC)(int, BYTE *);

void InitSetup(char *l, char *r);
void FreeSetup(void);
int DrawMenu(menuitem *items, PMENUPROC mp);
int DrawInfo(menuitem *item, PMENUPROC mp);
void DefMenuItem(menuitem *menu, int item);
void FillMenu(menuitem *menu, char *s, int l);

#endif
